       SUBROUTINE CHECKTRS(TRS,TRSFMT,MERIDIAN,HLF,MISTAKE)
C--------------------------------------------------------------------+
C Check for a valid legal location and format it to xxxTyyyRzzM.     |
C where T(ownship) is 'N' or 'S', R(ange) is 'E' or 'W'. Checks that |
C the section is between 1 and 36. If M(eridian) isn't present then  |
C the program attaches the the default meridian 'M'                      :
C234567--1---------2---------3---------4---------5---------6---------7

       CHARACTER*20 TRS,BC,YC
       CHARACTER*16 TRSFMT,XC,C*2
       INTEGER TOWNSHIP,RANGE,MERIDIAN,HLF,A,B
       MISTAKE=0                          
       TOWNSHIP=0
       RANGE=0
       TRSFMT='          '

c - - - - - - - - - - - - - - - - - - - - - - - - - - - - from ISHALF
c       TRS is input T/R/S
c       BC is TRS with '.5' left out
c       YC is TRS with '.5' replaced by '1/2'

      HLF=0
      A=INDEX(TRS,'.5N')
      B=INDEX(TRS,'.5S')
      IF(B.GT.A)A=B
      IF (A.GT.0) THEN
	 HLF=HLF+2
	 XC=TRS(1:A-1)//'.5'//TRS(A+2:)
       ELSE
	 XC=TRS
       END IF
	A=INDEX(XC,'.5E')
	B=INDEX(XC,'.5W')
	IF (B.GT.A)A=B
	IF (A.GT.0) THEN
	  HLF=HLF+1
	  YC=XC(1:A-1)//'.5'//XC(A+2:)
	ELSE
	  A=INDEX(XC,'.75E')
	  B=INDEX(XC,'.75W')
	  IF(B.GT.A)A=B
	  IF (A.GT.0)THEN
	    HLF=HLF+4
	    YC=XC(1:A-1)//'.75'//XC(A+3:)
	  ELSE
	    YC=XC
	  END IF
	END IF
	BC=' '
	J=1
	DO 5 I=1,16
	 IF(I.GT.2.AND.I.LT.15) THEN
	  IF(YC(I:I+1).EQ.'.5'.OR.YC(I-1:I).EQ.'.5')GOTO 5
	  IF(YC(I:I+2).EQ.'.75')GOTO 5
	  IF(YC(I-1:I+1).EQ.'.75')GOTO 5
	  IF(YC(I-2:I).EQ.'.75')GOTO 5
	 END IF
	     BC(J:J)=YC(I:I)
	     J=J+1
5       CONTINUE
	IF (HLF.GT.0) THEN
	  TRS=BC
	END IF
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - end ISHALF
C           --------------------------pick up the direction indicators
       DO 10 I=LEN(TRS), 1, -1
	   IF (TRS(I:I).EQ.'N') THEN
	       TOWNSHIP=I
	       TRSFMT(4:4)='N'
	   ENDIF
	   IF (TRS(I:I).EQ.'S') THEN
	       TOWNSHIP=I
	       TRSFMT(4:4)='S'
	   ENDIF
	   IF (TRS(I:I).EQ.'E') THEN
	       RANGE=I
	       TRSFMT(8:8)='E'
	   ENDIF
	   IF (TRS(I:I).EQ.'W') THEN
	      RANGE=I
	      TRSFMT(8:8)='W'
	   ENDIF
 10    CONTINUE

C    is 'N' or 'S'  missing?
       IF (TOWNSHIP.EQ.0) THEN
	  MISTAKE=1
	  RETURN
       ENDIF

C  is 'E' or 'W' missing?
       IF (RANGE.EQ.0) THEN
	   MISTAKE =2
	   RETURN
       ENDIF

C  odes the Range precede the Township?
       IF (RANGE.LT.TOWNSHIP) THEN
	  MISTAKE = 4
	  RETURN
       ENDIF

C   format the Township
       J=3
       DO 20 I=TOWNSHIP-1,1,-1
	 IF ((TRS(I:I).GE.'0').AND.(TRS(I:I).LE.'9')) THEN
C            is there more than 3 digits in Township
	     IF (J.EQ.0) THEN
		 MISTAKE=5
		 RETURN
	     ENDIF
	   TRSFMT(J:J)=TRS(I:I)
	   J=J-1
	 ENDIF
 20    CONTINUE

C   format the Range
       J=7
       DO 30 I=RANGE-1,TOWNSHIP+1,-1
	 IF ((TRS(I:I).GE.'0').AND.(TRS(I:I).LE.'9')) THEN
C           is there more than 3 digits in the Range
	    IF (J.EQ.4) THEN
	       MISTAKE=6
	       RETURN
	    ENDIF
	    TRSFMT(J:J)=TRS(I:I)
	    J=J-1
	 ENDIF
 30    CONTINUE

C      format the Section
       J=10
       DO 40 I=LEN(TRS),RANGE+1,-1
	  IF ((TRS(I:I).GE.'A').AND.(TRS(I:I).LE.'Z')) THEN
	     TRSFMT(11:12)=TRS(I:I+1)
	  ENDIF
	  IF ((TRS(I:I).GE.'0').AND.(TRS(I:I).LE.'9')) THEN
C            more than 2 digits in Section?
	     IF (J.EQ.8) THEN
	       MISTAKE=11
	       RETURN
	     ENDIF
	     TRSFMT(J:J)=TRS(I:I)
	     J=J-1
	  ENDIF
 40    CONTINUE
       MERIDIAN = MERID(TRSFMT(11:12))
       READ(TRSFMT,90) I,J,K
 90    FORMAT (I3,1X,I3,1X,I2,1X)
       IF (I.LT.1) MISTAKE=7
       IF (J.LT.1) MISTAKE=8
       IF ((K.LT.1).OR.(K.GT.36)) MISTAKE=9
C
c      LTYPE is type of T/R ie 1/2 etc
       LTYPE=0
	 ! get MERIDIAN off YC if it is there
       
	DO I=20,1,-1
	  IF(YC(I:I).GE.'0'.AND.YC(I:I).LE.'9')THEN
	    EXIT
        END IF
      END DO
	 TRS=YC(1:I)
       END

