      SUBROUTINE FINDAD(LAT1, LNG1, LAT2, LNG2, AZIMUTH, DISTANCE)

C---------------------------------------------------------------
C  Routine to find Azimuth and Distance Given
C  Origin Lat/Long(LAT1,LNG1) and
C  Destination Lat/Long (LAT2,LNG2)
C  Middle lattitude sailing formulas are used
C234567--1--------2--------3--------4--------5--------6--------7-+

      REAL LAT1,LNG1,LAT2,LNG2,L,LM,P
      L = ABS(LAT1 - LAT2) * 60.

C     ------------- dont let angles close to zero give an error.
      IF (L .LT. .001) L = .001
      DLO = ABS(LNG1 - LNG2) * 60.
      LM = (LAT1 + LAT2) / 2.

C    -------------- LM*2pi/360 to convert to radians.
      P = DLO * COS(LM*.0174533)
      C=ATAN(P/L)
C      ---   57.29578 is converting radians to degrees 360/2pi
      AZIMUTH = C*57.29578
      DISTANCE = L / COS(C)
      IF ((LAT1.LE. LAT2).AND.( LNG1.LT. LNG2)) AZIMUTH = 360.- AZIMUTH
      IF ((LAT1.GT.LAT2) .AND.(LNG1.GT. LNG2))  AZIMUTH = 180.- AZIMUTH
      IF ((LAT1.GT.LAT2).AND.(LNG1.LE.LNG2))    AZIMUTH = 180.+ AZIMUTH
      END
