C--------------------------------------------------------------------+
CThis subroutine converts a latitude and longitude to a legal location.
C234567--1---------2---------3---------4---------5---------6---------7

      SUBROUTINE LL2TRS (LATS, LNGS, TRS,CMERID,CSTATE,MISTAKE)
      REAL LT2, LG2,LATS,LNGS, LT1, LG1
      INTEGER CALIM,BTM,TOP,GETSECT,MISTAKE,ISTATE,STATEI
      CHARACTER*1 N,S,EW*3,TRS*16,TRS5*20
      CHARACTER*2 CMERID,NS,CSTATE,STATEC,MERIDCHR
       INCLUDE 'factdata.i'
C  this function is used to determine whether a location near the
C   Von Schmidt boundry is in California or Nevada. It was determined
C   thru regression analysis. An azimuth is taken from latitude 39,
C   longitude 120 to the location..
C  If the azimuth is greater than CANV(dist) the location is in Calif
!
!  ON 9/16/00 OPTIONAL STATE INPUT WAS ADDED!!. This was necessary because
!      on irregular state borders it could pick the wrong state
!
      CANV(X)=131.41218+.00457321*X
	ISTATE=STATEI(CSTATE)  !! added 9/15/00 optional state input
      CSTATE='  '
      TRS='no T/R/S   '
      MISTAKE = 14
C                          check for 1/2 sections first
	DO 5 I = 1,MAXhalf
	IF(ISTATE.GT.0.AND.V(I,7).NE.ISTATE)GOTO 5 ! added 9/15/00 optional state input
	  IF ((LATS.LE.Z(I,1)).AND.(LATS.GE.Z(I,2)).AND.
     +        (LNGS.GE.Z(I,3)).AND.(LNGS.LE.Z(I,4))) THEN
	  NS=' '
	  EW=' '
C           put 1/2 in proper place
	 IF (V(I,6).EQ.3)THEN
	    NS='.5'
	    EW='.5'
	  ENDIF
	  IF (V(I,6).EQ.1)EW='.5'
	  IF (V(I,6).EQ.2)NS='.5'
	  IF (V(I,6).EQ.4)EW='.75'
	  IF (V(I,6).EQ.6)THEN
	     NS='.5'
	     EW='.75'
	  END IF
	  AX = Z(I, 5)
	  BX = Z(I, 6)
	  AY = Z(I, 7)
	  BY = Z(I, 8)
	   Y = INT(((LATS - AY) / BY) -.5)
C          Y=  INT(((LATS - AY) / BY) +.5) is BASIC statement WHY???!!
C                  determine which regression transformation to use
	  IF (BX.GT.-.0167) THEN
	      X = (LNGS - AX) / BX
	      X = X * COS(LATS*.0174533)
	  ELSE
	      X = (LNGS - AX) / BX
	  END IF

	  IX=INT(X+SIGN(.5,X))
	   IF ((LATS-AY).LT.0.) THEN
	     Y=INT((LATS - AY)/BY +.5)
	   ELSE
	     Y=INT((LATS - AY)/BY -.5)
	   END IF
C          X=INT(X+.5)        in BASIC!!
	  X1 = INT(ABS(IX / 6) + 1)
	  Y1 = INT(ABS(Y / 6.) + 1)
	  N = 'S'
	  IF (Y.LT.0.)  N = 'N'
	  S = 'E'
	  IF (IX.LT.0) S = 'W'
	  CMERID = MERIDCHR(V(I, 5))
	  IXR = ABS(IX) - INT(ABS(IX / 6)) * 6
	  IF (X.LT.0.) THEN
	  IXR = 6 - IXR
	       IF (IXR.EQ.6) THEN
		 IXR = 0
		 X1 = X1 - 1.
	       END IF
	  END IF

	  YR = ABS(Y) - INT(ABS(Y / 6.)) * 6.
	  IF (Y.LT.0.) THEN
	      YR = 6. - YR
	      IF (YR.EQ.6.) THEN
		 YR = 0.
		 Y1 = Y1 - 1.
	      END IF
	   END IF

	 IY1=Y1
	 IX1=X1
	 IYR=YR

	 WRITE (TRS5,80)  IY1,NS,N,IX1,EW,S,GETSECT(IXR,IYR)
  80     FORMAT (I3,A2,A1,I3,A3,A1,I2)
	 TRS=' '
C         take spaces out of TRS so it fits in 11 characters
	 J=1
	 DO 85 K=1,20
	    IF(TRS5(K:K).NE.' ') THEN
	      TRS(J:J)=TRS5(K:K)
	      J=J+1
	    ENDIF
 85      CONTINUE
	 MISTAKE = 0
	 CSTATE=STATEC(V(I,7))
	 RETURN
	END IF
5     CONTINUE
C - - - - - - - - - - - - - - - - end of 1/2 trs 

      LT2 = LATS
      LG2 = LNGS
      LT1 = 39.
      LG1 = 120.
      CALL FINDAD(LT1, LG1, LT2, LG2, AZ, D)

C'-----------determine which factors to use
       IF (LNGS.LT.120.) THEN
	  IF (AZ.GT.CANV(D)) THEN
	     BTM = MINFACT
	     TOP = MAXFACT
	  ELSE
	     BTM = MINCANV
	     TOP = MAXCANV
	  END IF
      ELSE
	  BTM = MINFACT
	  TOP = MAXCANV
      END IF
C'------------------------------
169   DO 10 I = BTM ,TOP
       IF(ISTATE.GT.0.AND.V(I,7).NE.ISTATE)GOTO 10 ! added 9/15/00 optional state input     
      IF ((LATS.LE.Z(I, 1)).AND.(LATS.GE.Z(I, 2)).AND.
     +      (LNGS.GE.Z(I, 3)). AND.( LNGS.LE.Z(I,4))) THEN
	  AX = Z(I, 5)
	  BX = Z(I, 6)
	  AY = Z(I, 7)
	  BY = Z(I, 8)
C         Y=INT((LATS - AY) / BY) -.5)
C          Y=  INT(((LATS - AY) / BY) +.5) is BASIC statement WHY???!!
C                  determine which regression transformation to use
	  IF (BX.GT.-.0167) THEN
	      X = (LNGS - AX) / BX
	      X = X * COS(LATS*.0174533)
	  ELSE
	      X = (LNGS - AX) / BX
	  END IF
C
	   IX=INT(X+SIGN(.5,X))
	   IF ((LATS-AY).LT.0.) THEN
	     Y=INT((LATS - AY)/BY +.5)
	   ELSE
	     Y=INT((LATS - AY)/BY -.5)
	   END IF
C          X=INT(X+.5)        in BASIC!!
	  X1 = INT(ABS(IX / 6) + 1)
	  Y1 = INT(ABS(Y / 6.) + 1)
	  N = 'S'
	  IF (Y.LT.0.)  N = 'N'
	  S = 'E'
	  IF (IX.LT.0) S = 'W'
	  CMERID = MERIDCHR(V(I, 5))

	  IXR = ABS(IX) - INT(ABS(IX / 6)) * 6
	  IF (X.LT.0.) THEN
	  IXR = 6 - IXR
	       IF (IXR.EQ.6) THEN
		     IXR = 0
		     X1 = X1 - 1.
	       END IF
	  END IF
	  YR = ABS(Y) - INT(ABS(Y / 6.)) * 6.
	  IF (Y.LT.0.) THEN
	      YR = 6. - YR
	      IF (YR.EQ.6.) THEN
	    	 YR = 0.
		     Y1 = Y1 - 1.
	      END IF
	   END IF

	 IY1=Y1
	 IX1=X1
	 IYR=YR
	 IF(IX1.EQ.0)IX1=1  !  Why needed? I can't find bug

	!!!!!!!!!        CHECK IX1 CAN BE ZERO SOMETIME
	 TRS=' '
	 WRITE(TRS5,90)IY1,N,IX1,S,GETSECT(IXR,IYR)
  90     FORMAT (I3,A1,I3,A1,I2)
	 J=1
	 DO 95 K=1,20
	    IF(TRS5(K:K).NE.' ') THEN
	      TRS(J:J)=TRS5(K:K)
	      J=J+1
	    ENDIF
 95      CONTINUE
	 MISTAKE = 0
	 CSTATE=STATEC(V(I,7))
	 RETURN
       END IF
  10   CONTINUE
       IF(BTM.GT.1)THEN
	  BTM=1
	  TOP=MAXCANV
	  GOTO 169
       END IF
       END
