      SUBROUTINE 
     1 XBOUNDS(X,Y,BTM,TOP,LATS,LNGS,MISTAKE,MERID,STATE,LTYPE,ISTATE)
C------------------------------------------------------------------+
CThis subroutine takes the X, Y coordinates from the legal along with |
c its meridian suffix and returns the latitude and longitude.
CIf it is not in the FACTOR file MISTAKE is set to 13.         |
C234567-1---------2---------3--------4---------5---------6---------7-+


      INTEGER   STATE
	REAL*8 AX,BX,AY,BY
      CHARACTER*1 Q
      INCLUDE 'factdata.i'
c          Z                      V          
c      1 ( 1             2)1  min Y coord            
c      2 ( 3             4)2  max Y coord           
c      3 ( 5             6)3  min X coord           
c      4 ( 7             8)4  max X coord
c      5 ( 9            13)5  MERID-numeric value of meridian
c      6 (10            14)6  LTYPE-type of township/range -> 0
c      7 (11            15)7  STATE-numeric value of state    1
c      8 (12
c-----------
      INTEGER BTM,TOP           
      REAL LATS,LNGS
      MISTAKE = 13
      LATS=0.
      LNGS=0.
      IF(STATE.LT.1.AND.MERID.LT.64)THEN
	  MISTAKE=15         !  both state and meridian missing
	  RETURN
	END IF
      DO 10 I = BTM,TOP
	IF(MERID.NE.V(I,5))GOTO 10
	IF(LTYPE.NE.V(I,6))GOTO 10

	IF(STATE.GT.0.AND.V(I,7).NE.STATE)GOTO 10
	  IF((Y.GE.V(I,1)).AND.(Y.LE.V(I,2)).AND.(X.GE.V(I,3)).AND.
     1         (X.LE.V(I,4))) THEN
		AX = Z(I, 5)
		BX = Z(I, 6)
		AY = Z(I, 7)
		BY = Z(I, 8)
		LATS = (AY + BY * Y)
		 IF (BX.GT.-.0167) THEN
		   LNGS = (AX + BX * X / COS(LATS*.0174533))
		 ELSE
		  LNGS = AX + BX * X
		 END IF
		MISTAKE = 0
		ISTATE=V(I,7)
		RETURN
	 END IF
 10   CONTINUE
      IF(STATE.EQ.0) RETURN
      DO 11 I = BTM,TOP
	IF(LTYPE.NE.V(I,6))GOTO 11
	IF(V(I,7).NE.STATE)GOTO 11
	  IF((Y.GE.V(I,1)).AND.(Y.LE.V(I,2)).AND.(X.GE.V(I,3)).AND.
     1         (X.LE.V(I,4))) THEN
		AX = Z(I, 5)
		BX = Z(I, 6)
		AY = Z(I, 7)
		BY = Z(I, 8)
		LATS = (AY + BY * Y)
		 IF (BX.GT.-.0167) THEN
		   LNGS = (AX + BX * X / COS(LATS*.0174533))
		 ELSE
		  LNGS = AX + BX * X
		 END IF
		MISTAKE = 0
		ISTATE=V(I,7)
	    MERID=V(I,5)
		RETURN
	 END IF
 11   CONTINUE
      END
