

      INTEGER FUNCTION XPOS(N)

C----------------------------------------------------------------------+
C  These two functions converts legal sections to the equivilant       |
C  coordinates and visa versa.                                         |
C                                                                      |
C234567--1---------2---------3---------4---------5---------6---------7-+
C             0  1  2  3  4  5
C           +--+--+--+--+--+--+
C           | 6| 5| 4| 3| 2| 1| 0
C           +--+--+--+--+--+--+
C           | 7| 8| 9|10|11|12| 1
C           +--+--+--+--+--+--+
C           |18|17|16|15|14|13| 2
C           +--+--+--+--+--+--+
C           |19|20|21|22|23|24| 3
C           +--+--+--+--+--+--+
C           |30|29|28|27|26|25| 4
C           +--+--+--+--+--+--+
C           |31|32|33|34|35|36| 5
C           +--+--+--+--+--+--+


C  this function gives the x coordinate 0 thru 5 given the section N.

      DIMENSION NPOS(36)
      DATA NPOS/5,4,3,2,1,0,0,1,2,3,4,5,5,4,3,2,1,0,0,1,2,3,4,5,
     +5,4,3,2,1,0,0,1,2,3,4,5/
      IF ((N.GE.1).AND.(N.LE.36)) THEN
	    XPOS=NPOS(N)
      ELSE
	    XPOS=-1
      ENDIF
      END

